// Function for certificate manager

(function($, base_url) {

  var link_selector = '.node-requests-link',
      link_text = 'node requests';

  function update_text(count) {
    var link = $(link_selector);

    link.text(link_text + ' (' + count + ')');
  }

  function load_count() {
    return $.ajax({
      url: base_url + 'services/certificates/api/v1/csr_count',

      success: function(response) {
        var count = response.request_count;

        update_text(count);
      }
    });
  }

  load_count();

  return {
    update: load_count
  };

})(jQuery, '/console/');

// Function for licensing status

(function($, base_url) {

  var allowed_selector = '#license_allowed_usage',
      actual_selector = '#license_actual_usage',
      link_text = '';

  function update_text(selector, count) {
    var link = $(selector);

    link.text(link_text + count );
  }

  function load_license_count() {
    return $.ajax({
      url: base_url + 'services/licenses/api/v1/license_status',

      success: function(response) {
        var license_count = response.license_count;
        var node_count = response.node_count;
        var content = '';
        var footer_classes = 'popover-footer';

        update_text(allowed_selector, license_count);
        update_text(actual_selector, node_count);

        if (response.expired || (node_count > license_count)) {
          $("#license_warning_span").html('<img src="/images/icons/warning.png"></img>');
        }

        if (response.expired) {
          footer_classes = footer_classes + ' expired';
        }

        content = '<p>' + response.contact_us_text + '</p>' + '<p class="' + footer_classes + '">' + response.footer + '</p>';
        // add a custom template attribute so that the markup is similar
        // (not the same, but now valid and renders properly) across
        // the various appications where the popover is shown.
        // note: this is undocumented and probably subject to change
        // also add a custom class to the popover container to make sure
        // style overrides for this do not leak into any other popovers
        $("#license_link").popover({
          title: response.title,
          placement: 'bottom',
          html: true,
          content: content,
          template: '<div class="popover"><div class="arrow"></div><div class="popover-inner"><h3 class="popover-title"></h3><div class="popover-content"><div></div></div></div></div>'
        }).data('popover').tip().addClass('license-status-popover');
      }
    });
  }

  function refresh_license_data() {
    load_license_count();
  }

  refresh_license_data();

  return {
    update: refresh_license_data
  };

})(jQuery, '/console/');
